/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Defines the query parameters that can be provided in a request to the [ListCustomers](#endpoint-listcustomers) endpoint.
 */
@ApiModel(description = "Defines the query parameters that can be provided in a request to the [ListCustomers](#endpoint-listcustomers) endpoint.")

public class ListCustomersRequest {
  @JsonProperty("cursor")
  private String cursor = null;

  /**
   * Indicates how Customers should be sorted. Default: `DEFAULT`.
   */
  public enum SortFieldEnum {
    DEFAULT("DEFAULT"),
    
    CREATED_AT("CREATED_AT");

    private String value;

    SortFieldEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SortFieldEnum fromValue(String text) {
      for (SortFieldEnum b : SortFieldEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("sort_field")
  private SortFieldEnum sortField = null;

  /**
   * Indicates whether Customers should be sorted in ascending (`ASC`) or descending (`DESC`) order. Default: `ASC`.
   */
  public enum SortOrderEnum {
    DESC("DESC"),
    
    ASC("ASC");

    private String value;

    SortOrderEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SortOrderEnum fromValue(String text) {
      for (SortOrderEnum b : SortOrderEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("sort_order")
  private SortOrderEnum sortOrder = null;

  public ListCustomersRequest cursor(String cursor) {
    this.cursor = cursor;
    return this;
  }

   /**
   * A pagination cursor returned by a previous call to this endpoint. Provide this to retrieve the next set of results for your original query.  See [Paginating results](#paginatingresults) for more information.
   * @return cursor
  **/
  @ApiModelProperty(value = "A pagination cursor returned by a previous call to this endpoint. Provide this to retrieve the next set of results for your original query.  See [Paginating results](#paginatingresults) for more information.")
  public String getCursor() {
    return cursor;
  }

  public void setCursor(String cursor) {
    this.cursor = cursor;
  }

  public ListCustomersRequest sortField(SortFieldEnum sortField) {
    this.sortField = sortField;
    return this;
  }

   /**
   * Indicates how Customers should be sorted. Default: `DEFAULT`.
   * @return sortField
  **/
  @ApiModelProperty(value = "Indicates how Customers should be sorted. Default: `DEFAULT`.")
  public SortFieldEnum getSortField() {
    return sortField;
  }

  public void setSortField(SortFieldEnum sortField) {
    this.sortField = sortField;
  }

  public ListCustomersRequest sortOrder(SortOrderEnum sortOrder) {
    this.sortOrder = sortOrder;
    return this;
  }

   /**
   * Indicates whether Customers should be sorted in ascending (`ASC`) or descending (`DESC`) order. Default: `ASC`.
   * @return sortOrder
  **/
  @ApiModelProperty(value = "Indicates whether Customers should be sorted in ascending (`ASC`) or descending (`DESC`) order. Default: `ASC`.")
  public SortOrderEnum getSortOrder() {
    return sortOrder;
  }

  public void setSortOrder(SortOrderEnum sortOrder) {
    this.sortOrder = sortOrder;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ListCustomersRequest listCustomersRequest = (ListCustomersRequest) o;
    return Objects.equals(this.cursor, listCustomersRequest.cursor) &&
        Objects.equals(this.sortField, listCustomersRequest.sortField) &&
        Objects.equals(this.sortOrder, listCustomersRequest.sortOrder);
  }

  @Override
  public int hashCode() {
    return Objects.hash(cursor, sortField, sortOrder);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ListCustomersRequest {\n");
    
    sb.append("    cursor: ").append(toIndentedString(cursor)).append("\n");
    sb.append("    sortField: ").append(toIndentedString(sortField)).append("\n");
    sb.append("    sortOrder: ").append(toIndentedString(sortOrder)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

